'+--------------------------------------------------------------------------+
'|                                BareBone                                  |
'|                                                                          |
'|             Example of 32-bit OpenGL layered splash screen               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-02-2008 (MM-DD-YYYY)            |
'|                        Last revised : 10-02-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "BareBone.exe"

#INCLUDE "zSkin.inc"

%ULW_ALPHA                                      = &H00000002???
%AC_SRC_OVER                                    = &H00
%AC_SRC_ALPHA                                   = &H01

TYPE BBPTEXTURE
     ID       AS LONG
     FullName AS ASCIIZ * 260
     Texture  AS LONG
     Square   AS LONG            '// boolean TRUE or FALSE value
END TYPE

TYPE PIXELFORMATDESCRIPTOR
    nSize AS WORD
    nVersion AS WORD
    dwFlags AS DWORD
    iPixelType AS BYTE
    cColorBits AS BYTE
    cRedBits AS BYTE
    cRedShift AS BYTE
    cGreenBits AS BYTE
    cGreenShift AS BYTE
    cBlueBits AS BYTE
    cBlueShift AS BYTE
    cAlphaBits AS BYTE
    cAlphaShift AS BYTE
    cAccumBits AS BYTE
    cAccumRedBits AS BYTE
    cAccumGreenBits AS BYTE
    cAccumBlueBits AS BYTE
    cAccumAlphaBits AS BYTE
    cDepthBits AS BYTE
    cStencilBits AS BYTE
    cAuxBuffers AS BYTE
    iLayerType AS BYTE
    bReserved AS BYTE
    dwLayerMask AS DWORD
    dwVisibleMask AS DWORD
    dwDamageMask AS DWORD
END TYPE

%OBJ_BITMAP                     = 7

%PFD_TYPE_RGBA                  = 0
%PFD_DOUBLEBUFFER               = &H00000001
%PFD_DRAW_TO_WINDOW             = &H00000004
%PFD_DRAW_TO_BITMAP             = &H00000008
%PFD_SUPPORT_GDI                = &H00000010
%PFD_SUPPORT_OPENGL             = &H00000020
%PFD_GENERIC_ACCELERATED        = &H00001000
%PFD_SUPPORT_DIRECTDRAW         = &H00002000

%GL_LESS                        = &H0201
%GL_LEQUAL                      = &H0203
%GL_PROJECTION                  = &H1701
%GL_TEXTURE                     = &H1702
%GL_SMOOTH                      = &H1D01
%GL_DEPTH_TEST                  = &H0B71

%GL_DEPTH_BUFFER_BIT            = &H00000100
%GL_COLOR_BUFFER_BIT            = &H00004000
%GL_QUADS                       = &H0007???

%GL_BLEND                       = &H0BE2
%GL_MODELVIEW                   = &H1700
%GL_LIGHT0                      = &H4000???
%GL_TRIANGLE_FAN                = &H0006
%GL_QUAD_STRIP                  = &H0008???
%GL_FRONT                       = &H0404&
%GL_FRONT_AND_BACK              = &H0408???
%GL_AMBIENT_AND_DIFFUSE         = &H1602???
%GL_COLOR_MATERIAL              = &H0B57???
%GL_UNSIGNED_BYTE               = &h1401&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_NICEST                      = &h1102&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907
%GL_RGBA                        = &H1908
%GL_LIGHTING                    = &H0B50
%GL_GREATER                     = &H0204
%GL_POSITION                    = &H1203???
%GL_LIGHT_MODEL_TWO_SIDE        = &H0B52???
%GL_NORMALIZE                   = &H0BA1???
%GL_AMBIENT                     = &H1200???
%GL_DIFFUSE                     = &H1201???
%GL_SPECULAR                    = &H1202???
%GL_POSITION                    = &H1203???
%GL_TRUE                        = 1
%GL_FALSE                       = 0
%GLU_SMOOTH                     = 100000
%GL_ONE_MINUS_SRC_ALPHA         = &H0303&
%GL_ALPHA_TEST                  = &H0BC0&
%GL_ALWAYS                      = &H0207&

DECLARE FUNCTION ChoosePixelFormat LIB "GDI32.DLL" ALIAS "ChoosePixelFormat" (BYVAL hDC AS DWORD, pPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION SetPixelFormat LIB "GDI32.DLL" ALIAS "SetPixelFormat" (BYVAL hDC AS DWORD, BYVAL n AS LONG, pcPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG

DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG

DECLARE FUNCTION wglCreateContext LIB "OPENGL32.DLL" ALIAS "wglCreateContext" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE FUNCTION wglDeleteContext LIB "OPENGL32.DLL" ALIAS "wglDeleteContext" (BYVAL hglrc AS DWORD) AS LONG

DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL x&, BYVAL y&, BYVAL nwidth&, BYVAL nheight&)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL depth AS DOUBLE)
DECLARE SUB glDepthFunc LIB "opengl32.dll" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL cap AS DWORD)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL MODE AS DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL MODE AS DWORD)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)

DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor3ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL Alpha AS BYTE)
DECLARE SUB glNormal3f LIB "OPENGL32.DLL" ALIAS "glNormal3f" ( BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE )
DECLARE SUB gluLookAt LIB "glu32.dll" ALIAS "gluLookAt" (BYVAL eyex#, BYVAL eyey#, BYVAL eyez#, BYVAL centerx#, BYVAL centery#, BYVAL centerz#, BYVAL upx#, BYVAL upy#, BYVAL upz AS DOUBLE)
DECLARE SUB glColorMaterial LIB "OPENGL32.DLL" ALIAS "glColorMaterial" ( BYVAL DWORD, BYVAL DWORD )
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS ANY)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS ANY)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glLightfv LIB "OPENGL32.DLL" ALIAS "glLightfv" ( BYVAL DWORD, BYVAL DWORD, BYREF SINGLE )
DECLARE SUB glLightModeli LIB "OPENGL32.DLL" ALIAS "glLightModeli" ( BYVAL DWORD, BYVAL LONG )
DECLARE SUB glScalef LIB "OPENGL32.DLL" ALIAS "glScalef" ( BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE )
DECLARE SUB glMaterialf LIB "OPENGL32.DLL" ALIAS "glMaterialf" ( BYVAL DWORD, BYVAL DWORD, BYVAL SINGLE )
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glDepthMask LIB "OPENGL32.DLL" ALIAS "glDepthMask" ( BYVAL BYTE )
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glFlush LIB "OPENGL32.DLL" ALIAS "glFlush" ()

DECLARE FUNCTION GetDIBits LIB "GDI32.DLL" ALIAS "GetDIBits" (BYVAL hdc AS DWORD, BYVAL hBitmap AS DWORD, BYVAL nStartScan AS DWORD, BYVAL nNumScans AS DWORD, lpBits AS ANY, lpBI AS MYBITMAPINFO, BYVAL wUsage AS DWORD) AS LONG
DECLARE FUNCTION GdipBitmapGetPixel LIB "gdiplus.dll" ALIAS "GdipBitmapGetPixel" (BYVAL nBitmap&, BYVAL x&, BYVAL y&, Colr&) AS LONG

DECLARE FUNCTION wglSwapBuffers LIB "OPENGL32.DLL" ALIAS "wglSwapBuffers" (BYVAL hdc AS DWORD) AS DWORD

DECLARE FUNCTION GetCurrentObject LIB "GDI32.DLL" ALIAS "GetCurrentObject" (BYVAL hdc AS DWORD, BYVAL uObjectType AS DWORD) AS DWORD

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------
%FRAME_SizeX = 200 '// The animation frame width
%FRAME_SizeY = 200 '// The animation frame height
%TIMER_DELAY = 0  '// The timer delay (animation speed)  gnCtrl,

GLOBAL hGLDC, hGLRC AS LONG
GLOBAL mt() AS BBPTEXTURE

'//  JH_OpacityLevel(0,0)'
FUNCTION JH_OpacityLevel ALIAS "JH_OpacityLevel" (BYVAL nextOpacityLevel AS LONG, BYVAL rw AS LONG) EXPORT AS LONG
    STATIC IsOpacityLevel, isSaved AS LONG
      ' if not saved and try to read, set it to default Value
      IF NOT isSaved AND nextOpacityLevel = 0 AND IsOpacityLevel = 0 AND rw = 0 THEN isSaved = -1 : IsOpacityLevel = 200  '<-- default
      IF rw <> 0 THEN IsOpacityLevel = nextOpacityLevel
    FUNCTION = IsOpacityLevel
END FUNCTION
'//  JH_AlphaLevel(0,0)'
FUNCTION JH_AlphaLevel ALIAS "JH_AlphaLevel" (BYVAL nextAlphaLevel AS LONG, BYVAL rw AS LONG) EXPORT AS LONG
    STATIC IsAlphaLevel, isSaved AS LONG
      ' if not saved and try to read, set it to default Value
      IF NOT isSaved AND nextAlphaLevel = 0 AND IsAlphaLevel = 0 AND rw = 0 THEN isSaved = -1 : IsAlphaLevel = 255 '<-- default
      IF rw <> 0 THEN IsAlphaLevel = nextAlphaLevel
    FUNCTION = IsAlphaLevel
END FUNCTION


'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEX
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS DWORD
'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZAEROGL"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = GetModuleHandle("")
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

'   // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED OR %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "AeroGL"
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

'         // The OpenGL stuff
          CALL CreateGLcontext(rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, hGLDC, hGLRC)
          DIM mt(1 TO 1) AS BBPTEXTURE
          mt(1).FullName = EXE.PATH$ + "rainbow.png":   mt(1).ID = 1: mt(1).Square = 0
          CALL MakeMutipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)
          CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)

          CALL ShowWindow(hMain, %SW_SHOW)

          CALL SetTimer(hMain, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          CALL KillTimer(hMain, 1)

          '//FreeUp resources
        '  IF ghBmp THEN
        '     CALL DeleteObject(ghBmp)
        '     CALL DeleteDC(ghMemDC)
        '  END IF
          CALL DestroyGLresources(hGLDC, hGLRC)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg

    CASE %WM_COMMAND
         'IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION
         SELECT CASE LONG LO(INTEGER, wParam)
         CASE %ID_CLOSE
              CALL SendMessage(hWnd, %WM_CLOSE, 0, 0)
         END SELECT

    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF

    CASE %WM_TIMER
         CALL SetImage(hWnd)

    CASE %WM_NCHITTEST
         FUNCTION = %HTCAPTION: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
    'FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB SetImagePatrice(BYVAL hWnd AS LONG)
    LOCAL graphics, DesktopDC, Img, imgW, imgH, ImgAttr, x, y AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL

    STATIC xMove3, FlipMove3 AS LONG

    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

    DesktopDC = GetDC(0)

    '// Draw active frame to new memory DC
'    IF ghBmp = 0 THEN
'       ghMemDC = CreateCompatibleDC(DesktopDC)
'       ghBmp = zCreateDIBSection(DesktopDC, lpSize.Cx, lpSize.CY, 32)
'       CALL SelectObject(ghMemDC, ghBmp)
'    END IF

'   // Draw the OpenGL scene
    CALL DrawTheScene()
    CALL wglMakeCurrent(hGLDC, hGLRC)
    CALL wglSwapBuffers(hGLDC)
'    CALL DrawAndSetupAlphaChannel(ghMemDC, 0, 0)

'   // Update the layered window
    bf.BlendOp             = %AC_SRC_OVER
    bf.BlendFlags          = 0
    bf.AlphaFormat         = %AC_SRC_ALPHA '// Use source alpha
    bf.SourceConstantAlpha = 255 '//alpha
'    CALL UpdateLayeredWindow (hWnd, DesktopDC, lp, lpSize, ghMemDC, ptSrc, 0, bf, %ULW_ALPHA)

    CALL ReleaseDC(0, DesktopDC)
END SUB

SUB SetImage(BYVAL hWnd AS LONG)
    LOCAL x, y, DIS_IC, ImgAttr AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL

'    STATIC xMove3, FlipMove3 AS LONG

    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

'   // Draw the OpenGL scene
    CALL DrawTheScene()
    CALL wglMakeCurrent(hGLDC, hGLRC)
'    CALL wglSwapBuffers(hGLDC)   ' Don`t SwapBuffers here, we are drawing the just rendered GLDC-Bitmap via DisplayDC
    CALL SetupAlphaChannel(hGLDC) ' by the UpdateLayerdWindow function into our Window after the SetupAlphaChannel without BitBlt
'   // Update the layered window
    bf.BlendOp             = %AC_SRC_OVER
    bf.BlendFlags          = 0
    bf.AlphaFormat         = %AC_SRC_ALPHA       '// Use source alpha
    bf.SourceConstantAlpha = JH_AlphaLevel(0,0) '// Setup the alpha level

    DIS_IC = CreateIC("DISPLAY", BYVAL 0, BYVAL 0, BYVAL 0)
    CALL UpdateLayeredWindow (hWnd, DIS_IC, lp, lpSize, hGLDC, ptSrc, 0, bf, &H00000002) ' %ULW_ALPHA)
    CALL DeleteDC(DIS_IC)
    CALL glFlush()
END SUB

SUB DrawTheScene() ' See MSDN documentation for the use of the OpenGL API

    STATIC nFlip AS LONG
    nFlip = NOT nFlip
    IF nFlip = 0 THEN EXIT SUB '// To save CPU resource

    STATIC xrot AS SINGLE, yrot AS SINGLE, zrot AS SINGLE

    CALL glClearColor(0.0, 0.0, 0.0, 0.0)
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    CALL glLoadIdentity()

    CALL gluPerspective(42.0, 1.0, 1.0, 100.0)

    CALL glTranslatef(0.0, 0.0, -5.0)

    CALL glRotatef(xrot, 1.0, 0.0, 0.0)                             ' Rotate On The X Axis
    CALL glRotatef(yrot, 0.0, 1.0, 0.0)                             ' Rotate On The Y Axis
    CALL glRotatef(zrot, 0.0, 0.0, 1.0)                             ' Rotate On The Z Axis

    CALL glBegin(%GL_QUADS)
     ' Front Face
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
     ' Back Face
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Bottom Left Of The Texture And Quad
     ' Top Face
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
     ' Bottom Face
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
     ' Right face
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
     ' Left Face
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
    CALL glEnd()

    xrot = xrot + 0.6  ' X Axis Rotation
    yrot = yrot + 0.4  ' Y Axis Rotation
    zrot = zrot + 0.8  ' Z Axis Rotation

END SUB

FUNCTION Rgb2Gray ALIAS "Rgb2Gray" (BYVAL RGBValue AS DWORD) EXPORT AS DWORD
'    #REGISTER NONE

    !XOR ESI, ESI
    !XOR EDX, EDX
    !MOV ECX, RGBValue

  ' Red
    !MOV EAX, 19595
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Green
    !MOV EAX, 38470
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Blue
    !MOV EAX, 7471
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    !SHR ESI, 16
    !MOV EDX, ESI

  ' Put Gray Value to a DWORD (0GGG)
    !XOR EAX, EAX
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL

    !MOV FUNCTION, EAX

END FUNCTION

SUB DrawAndSetupAlphaChannel(BYVAL hMemDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG)
'   // We must do this to be compatible with BitBlt
'   // We compute a fake alpha channel based on color conversion to shade of gray
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P AS LONG
    CALL GetObject(GetCurrentObject(hGLDC, 7), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        @pBits[3] = MIN&(Alpha& * 255, 55)
        pBits = pBits + 4
    NEXT
    CALL BitBlt(hMemDC, x, y, bm.bmWidth, bm.bmHeight, hGLDC, 0, 0, %SRCCOPY)
END SUB

SUB SetupAlphaChannel(BYVAL hDC AS LONG)
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P, Alpha AS LONG
    CALL GetObject(GetCurrentObject(hDC, %OBJ_BITMAP), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        IF Alpha& = 0 AND @pBits[3] = 0 THEN
           @pBits[3] = 0
        ELSE
           IF @pBits[3] = 0 THEN @pBits[3] = JH_OpacityLevel(0,0) ' // Setup the opacity level
        END IF
        pBits = pBits + 4
    NEXT
END SUB


FUNCTION zSetupPixelFormat(BYVAL hDC AS LONG) AS LONG
    LOCAL pfd AS PIXELFORMATDESCRIPTOR
    LOCAL pixelformat AS LONG
    LOCAL lRet AS LONG

    lRet = %TRUE

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    pfd.dwFlags    = %PFD_GENERIC_ACCELERATED OR %PFD_SUPPORT_DIRECTDRAW OR %PFD_SUPPORT_OPENGL OR %PFD_SUPPORT_GDI OR %PFD_DRAW_TO_BITMAP ' don`t use -> %PFD_DRAW_TO_WINDOW - UpdateLayeredWindow draw to the Window
    pfd.iPixelType = %PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    IF pixelformat THEN
       IF SetPixelFormat(hDC, pixelformat, pfd) = 0 THEN lRet = %FALSE
    ELSE
       lRet = %FALSE
    END IF

    FUNCTION = lRet
END FUNCTION

FUNCTION CreateGLcontext(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYREF hGLDC AS LONG, BYREF hGLRC AS LONG) AS LONG
    LOCAL nRet, DesktopDC, hGLBMP AS LONG
    IF nWidth > 0 AND nHeight > 0 THEN
       DesktopDC = GetDC(0)
       hGLDC = CreateCompatibleDC(DesktopDC)
       hGLBMP = zCreateDIBSection(DesktopDC, nWidth, nHeight, 32)
       CALL SelectObject(hGLDC, hGLBMP)
       CALL ReleaseDC(0, DesktopDC)
       IF hGLBMP THEN
          IF zSetupPixelFormat(hGLDC) THEN
            hGLRC = wglCreateContext(hGLDC)
            IF hGLRC THEN
               IF wglMakeCurrent(hGLDC, hGLRC) THEN

                  CALL glClearColor(0.0, 0.0, 0.0, 0.0)
                  CALL glClearDepth(1.0)
                  CALL glDepthFunc(%GL_LEQUAL)'LESS)'GREATER)'LEQUAL)'ALWAYS)
                  CALL glEnable(%GL_DEPTH_TEST)
                  CALL glShadeModel(%GL_SMOOTH)

                  CALL glMatrixMode(%GL_PROJECTION)

                  CALL glViewport(0, 0, nWidth, nHeight)

                  CALL glEnable(%GL_TEXTURE_2D)

'                 // Use alphablending
                  CALL glEnable(%GL_BLEND)
                  CALL glBlendFunc(%GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA)

                  nRet = -1

               END IF
            END IF
          END IF
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

SUB DestroyGLresources(BYREF hGLDC AS LONG, BYREF hGLRC AS LONG)
    IF hGLRC THEN
       CALL wglMakeCurrent(hGLDC, 0)
       CALL wglDeleteContext(hGLRC): hGLRC = 0
    END IF
    IF hGLDC THEN
       CALL DeleteObject(GetCurrentObject(hGLDC, %OBJ_BITMAP)) ' Delete the memory bitmap
       CALL DeleteDC(hGLDC): hGLDC = 0
    END IF
END SUB

FUNCTION CreateGLTextureFromFile (zFullPath AS ASCIIZ, Xin AS LONG, Yin AS LONG, PixelArray() AS BYTE, BYVAL SquareTexture AS LONG) AS LONG
    LOCAL bi AS MYBITMAPINFO, bm AS BITMAP
    LOCAL pBits AS BYTE PTR, SCALE AS SINGLE
    LOCAL K, xP, yP, xS, yS, So, hDIB, hIC, hDC, Img, imgW, imgH, ImgAttr AS LONG
    LOCAL sImgName, sPathName AS STRING
    LOCAL ARGBcolor AS LONG, A, R, G, B AS BYTE

    Xin = 0: Yin = 0: imgW = 0: imgH = 0

  ' Make sure that a full path is being used.
    sImgName = zFullPath: REPLACE "/" WITH $Anti IN sImgName
    IF INSTR(sImgName, EXE_Path$) = 0 THEN sImgName = sPathName + sImgName

    So = INSTR(-1, sImgName, $Dot)
    IF So AND NOT ISFILE((sImgName)) THEN So = 0
    IF So THEN
       ImgType$ = UCASE$(MID$(sImgName, So)) + $Dot
       ImageType& = INSTR(".BMP.DIB.GIF.ICO.JPG.JPEG.PNG.TIF.TIFF.", ImgType$)
       IF ImageType& THEN
        ' Load the image
          IF GdipLoadImageFromFile((UCODE$(sImgName)), Img) = 0 THEN
           ' Get the image height and width
             CALL zGetImageSize(Img, imgW, imgH)

             DIM P(1 TO 12) AS LONG
             ARRAY ASSIGN P() = 2,4,8,16,32,64,128,256,512,1024,2048,4096
             FOR K& = UBOUND(P) TO LBOUND(P) STEP -1
                 IF Xin = 0 AND ImgW > P(K&) - 1 THEN Xin = P(K&)
                 IF Yin = 0 AND ImgH > P(K&) - 1 THEN Yin = P(K&)
             NEXT

             IF SquareTexture AND Xin <> Yin THEN
                Xin = MAX&(Xin, Yin): Yin = Xin
             ELSE
                SquareTexture = 0
             END IF

           ' Perform scale adjustment (zIconise(imgW, imgH, Xin, Yin, xP, yP, xS, yS))
           ' ------------------------------------------------------------------------
             IF imgW THEN SCALE = Xin / imgW
             IF SCALE > 1 THEN SCALE = 1
              xS = imgW * SCALE: yS = imgH * SCALE
             ' In case Height > Yin compute new scale factor
             IF yS > Yin THEN
                IF imgH THEN SCALE = Yin / imgH
                xS = imgW * SCALE: yS = imgH * SCALE
             END IF
             xP = (Xin - xS) \ 2: yP = (Yin - yS) \ 2
            ' ------------------------------------------------------------------------

             hIC = CreateIC("DISPLAY", BYVAL 0, BYVAL 0, BYVAL 0)
             hDC = CreateCompatibleDC(hIC)

             bi.bmiHeader.biSize = SIZEOF(bi.bmiHeader)
             bi.bmiHeader.biWidth = Xin
             bi.bmiHeader.biHeight = Yin
             bi.bmiHeader.biPlanes = 1
             bi.bmiHeader.biBitCount = 32
             bi.bmiHeader.biCompression = 0 ' %BI_RGB
             hDIB = MyCreateDIBSection(hDC, bi, 0, 0, 0, 0)

             CALL SelectObject(hDC, hDIB)
           ' Draw image
             IF GdipCreateFromHDC(hDC, graphics&) = 0 THEN

              ' Set up stretching QualityMode
                CALL GdipSetInterpolationMode(graphics&, 2)

              ' Fill the background with color of pixel(0,0)
                IF SquareTexture THEN
                   CALL GdipBitmapGetPixel(img, 0, 0, ARGBcolor)
                   CALL zSplitColorARGB(ARGBcolor, A, R, G, B)
                   CALL GetObject(hDIB, SIZEOF(bm), bm)
                   pBits = bm.bmBits
                   FOR K = (Xin * Yin) TO 1 STEP - 1
                       @pBits[3] = A
                       @pBits[2] = R
                       @pBits[1] = G
                       @pBits[0] = B
                       pBits = pBits + 4
                   NEXT
                END IF

              ' Draw image
                IF GdipDrawImageRectRectI(graphics&, Img, _
                                    xP, yP, xS, yS, _
                                    0, 0, ImgW, ImgH, %UnitPixel, _
                                    ImgAttr) = 0 THEN ' This is an optional parameter
                   bi.bmiHeader.biSize        = SIZEOF(bi.bmiHeader)
                   bi.bmiHeader.biWidth       = Xin
                   bi.bmiHeader.biHeight      = Yin
                   bi.bmiHeader.biPlanes      = 1
                   bi.bmiHeader.biBitCount    = 32
                   bi.bmiHeader.biCompression = 0 ' %BI_RGB
                   REDIM PixelArray(0 TO Xin * Yin * 4 - 1) AS BYTE
                   IF GetDIBits(hDC, hDIB, 0, Yin, PixelArray(0), BYVAL VARPTR(bi), 0) THEN
                   '  Perform Red and Green permutation
                      pBits = VARPTR(PixelArray(0))
                      FOR K = (Xin * Yin) TO 1 STEP - 1
                          R = @pBits[2]: @pBits[2] = @pBits[0]: @pBits[0] = R: pBits = pBits + 4
                      NEXT
                      FUNCTION = -1
                   END IF
                END IF
              ' Cleanup
                'IF ImgAttr THEN CALL GdipDisposeImageAttributes(ImgAttr)
                CALL GdipDeleteGraphics(graphics&)
             END IF
             CALL DeleteObject(hDIB)
             IF hDC THEN CALL DeleteDC(hDC)
             IF hIC THEN CALL DeleteDC(hIC)
          END IF
          CALL GdipDisposeImage(Img): Img = 0
       END IF
    END IF

END FUNCTION

SUB MakeMutipleTexture (BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL mtCount, K, nRet, xSize, ySize AS LONG
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       CALL glDeleteTextures(mtCount, Texture(1))
       CALL glGenTextures(mtCount, Texture(1)): nRet = glGetError()
       IF nRet = 0 THEN
          FOR K = 1 TO mtCount
              REDIM PixelArray(0) AS BYTE
              IF CreateGLTextureFromFile(mt(K).FullName, xSize, ySize, PixelArray(), mt(K).Square) THEN
                 mt(k).Texture = Texture(K)
                 CALL glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                 IF nRet = 0 THEN
                    CALL glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                    CALL glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                    CALL glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_BYTE, PixelArray(0))
                 END IF
              END IF
          NEXT
       END IF
    END IF
END SUB
